import processing.core.*; 
import processing.xml.*; 

import processing.serial.*; 
import controlP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class NU32_utility extends PApplet {


 // serial library


Serial[] comPorts = new Serial[2];

ControlP5 controlP5;
ControlFont font;

// plot buffers
int[] buffA = new int[500];
int[] buffB = new int[500];
int[] buffC = new int[500];
int[] buffD = new int[500];
int[] buffE = new int[500];
int[] buffF = new int[500];
int rollingIndex;

int[] crc_table = {
  0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50a5, 0x60c6, 0x70e7, 
  0x8108, 0x9129, 0xa14a, 0xb16b, 0xc18c, 0xd1ad, 0xe1ce, 0xf1ef
};

Textlabel txtlblBootcom;
ListBox bootListbox;
Button butCloseBoot;
Button butExit;

Textlabel txtlblDebugcom;
ListBox debugListbox;
Button butCloseDebug;

Button butSelecthex;
Textlabel txtlblHex;
Button butRequestboot;
Button butConnect;
Button butProgram;
Button butRun;
Textarea bootTextarea;

RadioButton debugTypeRadio;

Textfield inputTextfield;
Textarea recTextarea;
Button butClearDebug;
Button butSaveDebug;

Button butClearPlot;
Button butSavePlot;

float[] plotData;

Boolean serialBootOK;
Boolean serialDebugOK;
String serialBootcom;
String serialDebugcom;

String loadPath;
Boolean havePath;

String rec;
String plotRec;
String recString;

Boolean plotMode;

int mode;
int program, requestBoot, tryConnect;
int linesDone, prevGoTo;

float nextPercent;

public void setup() {
  size(715, 600);
  smooth();
  frameRate(30);

  serialBootOK = false;
  serialDebugOK = false;

  for (int i = 0; i < 500; i++) {
    buffA[i] = 0;
    buffB[i] = 0;
    buffC[i] = 0;
    buffD[i] = 0;
    buffE[i] = 0;
    buffF[i] = 0;
  }
  rollingIndex = 0;

  controlP5 = new ControlP5(this);
  //controlP5.setControlFont(new ControlFont(createFont("Georgia",20), 20));
  controlP5.setColorBackground( color( 207, 237, 252 ) );
  controlP5.setColorForeground( color( 167, 216, 240 ) );
  controlP5.setColorActive( color( 137, 198, 227 ) );
  controlP5.setColorLabel(0);

  PFont pfont = createFont("Verdana", 20, true); // use true/false for smooth/no-smooth
  font = new ControlFont(pfont);

  create_boot_serial();
  create_debug_serial();

  butExit = controlP5.addButton("Exit_App", 1, 10, 570, 170, 20); // buton(name,value,x,y,width,height)

  butSelecthex = controlP5.addButton("Select_HEX", 1, 10, 75, 170, 20); // buton(name,value,x,y,width,height)
  butSelecthex.setVisible(false);
  txtlblHex = controlP5.addTextlabel("txtlblHex", "No HEX file selected", 10, 105); // textlabel(name,text,x,y)
  txtlblHex.setColorValueLabel(0);
  txtlblHex.setVisible(false);
  butRequestboot = controlP5.addButton("Request_Boot", 1, 10, 125, 80, 20); // buton(name,value,x,y,width,height)
  butRequestboot.setVisible(false);
  butConnect = controlP5.addButton("Connect", 1, 100, 125, 80, 20); // buton(name,value,x,y,width,height)
  butConnect.setVisible(false);
  butProgram = controlP5.addButton("Program", 1, 10, 150, 170, 20); // buton(name,value,x,y,width,height)
  butProgram.setVisible(false);
  butRun = controlP5.addButton("Run", 1, 10, 175, 170, 20); // buton(name,value,x,y,width,height)
  butRun.setVisible(false);

  bootTextarea = controlP5.addTextarea("boot", "", 10, 200, 170, 365); // addTextarea(name,text,x,y,width,height)
  bootTextarea.showScrollbar();
  bootTextarea.scroll(1);
  bootTextarea.setColor(0x000000); // text color
  //bootTextarea.enableColorBackground();
  bootTextarea.setColorBackground(color(255, 255, 255));
  bootTextarea.setVisible(false);

  debugTypeRadio = controlP5.addRadioButton("DebugType", 210, 50);
  debugTypeRadio.setVisible(false);
  //debugTypeRadio.deactivateAll();
  debugTypeRadio.addItem("Text", 0);
  debugTypeRadio.addItem("Plot", 1);
  debugTypeRadio.setNoneSelectedAllowed(false);

  inputTextfield = controlP5.addTextfield("Send_to_NU32", 250, 50, 200, 20); // addTextfield(name,x,y,width,height)
  inputTextfield.setVisible(false);
  inputTextfield.keepFocus(false);
  inputTextfield.setColorValueLabel(0);
  inputTextfield.setColorBackground(color(255, 255, 255));

  recTextarea = controlP5.addTextarea("text", "", 210, 100, 490, 490); // addTextarea(name,text,x,y,width,height)
  recTextarea.showScrollbar();
  recTextarea.scroll(1);
  recTextarea.setColor(0x000000); // text color
  //recTextarea.enableColorBackground();
  recTextarea.setColorBackground(color(255, 255, 255));
  recTextarea.setVisible(false);

  butClearDebug = controlP5.addButton("Clear_Debug", 1, 460, 50, 80, 20); // buton(name,value,x,y,width,height)
  butClearDebug.setVisible(false);

  butSaveDebug = controlP5.addButton("Save_Debug", 1, 550, 50, 80, 20); // buton(name,value,x,y,width,height)
  butSaveDebug.setVisible(false);

  //plotChart = controlP5.addChart("Plot",210,75,500,512);

  butClearPlot = controlP5.addButton("Clear_Plot", 1, 460, 50, 80, 20); // buton(name,value,x,y,width,height)
  butClearPlot.setVisible(false);

  butSavePlot = controlP5.addButton("Save_Plot", 1, 550, 50, 80, 20); // buton(name,value,x,y,width,height)
  butSavePlot.setVisible(false);

  serialBootcom = "";
  serialDebugcom = "";

  loadPath = "";
  havePath = false;

  rec = "";
  plotRec = "";
  recString = "";

  plotMode = false;

  mode = 0;
  program = 0;
  requestBoot = 0;
  tryConnect = 0;

  linesDone = 0;
  prevGoTo = 0;

  nextPercent = 0;
}

public void draw() {
  background(224);
  fill(95);
  rect(200, 0, 5, height);

  if (requestBoot == 1) {
    comPorts[0].write("B");
    delay(100);
    comPorts[0].write("B");
    bootTextarea.setText(bootTextarea.text() + "Boot requested...\n");
    delay(100);
    requestBoot = 0;
    tryConnect = 1;
    Connect(0);
  }
  else if (tryConnect == 1) {
    byte[] connect_message = {
      1
    };
    bootTextarea.setText(bootTextarea.text() + "Trying to connect...\n");

    message(connect_message, 1, CalculateCrc(connect_message));
    mode = 1;
    tryConnect = 2;
  }
  else if (tryConnect == 2) {
    float initTime = millis();
    while (mode == 1) {
      if (millis()-initTime > 10000) {
        println("did not connect");
        bootTextarea.setText(bootTextarea.text() + "Could not connect...\n");
        butProgram.setVisible(false);
        butRun.setVisible(false);
        tryConnect = 0;
        break;
      }
    }
    if (tryConnect == 2) {
      butProgram.setVisible(true);
      butRun.setVisible(true);
    }
    tryConnect = 0;
  }

  else if (program == 1) {
    if (havePath) {
      byte[] connect_message = {
        2
      };
      println("erase"); // print it to the debug screen as well
      bootTextarea.setText(bootTextarea.text() + "Erasing flash...\n");

      message(connect_message, 1, CalculateCrc(connect_message));
      program = 2;
    }
    else {
      // dont have a hex file selected yet
      bootTextarea.setText(bootTextarea.text() + "Select a HEX file!\n");
      program = 0;
    }
  }
  else if (program == 2) {
    float initTime;
    mode = 2;
    initTime = millis();
    while (mode == 2) {
      if (millis()-initTime > 10000) {
        println("did not erase");
        bootTextarea.setText(bootTextarea.text() + "Could not erase...\n");
        program = 0;
        break;
      }
    }
    if (program == 2) {
      program = 3;
    }
    else {
      //butProgram.setVisible(false);
      //butRun.setVisible(false);
    }
  }
  else if (program == 3) {
    // make binary
    println("making the binary");
    String lines[] = loadStrings(loadPath);

    int i, k, j, numTotal, num;
    float initTime;
    float percent;

    numTotal = 0;
    for (i=0; i<lines.length; i++) {
      numTotal = numTotal + lines[i].length() - 1;
    }

    numTotal = numTotal/2;
    println("total num bytes = " + numTotal);

    if (linesDone < lines.length) {
      num = 0;
      int goTo;
      if (linesDone+10 > lines.length) {
        goTo = lines.length;
        linesDone = goTo;
      }
      else {
        goTo = linesDone + 10;
        linesDone = goTo;
      }
      println("goTo = " + goTo + " prevGoTo = " + prevGoTo + " lines done = " + linesDone + " out of " + lines.length);
      for (i=prevGoTo; i<goTo; i++) {
        num = num + lines[i].length() - 1;
      }

      byte[] connect_message = new byte[num];

      connect_message[0] = 3; // program flash
      j = 1;
      for (i=prevGoTo; i<goTo; i++) {
        //println(lines[i]);
        for (k=1; k<lines[i].length(); k=k+2) {
          connect_message[j] = PApplet.parseByte(unhex(lines[i].substring(k, k+2)));
          //println(lines[i].substring(k, k+2) + " " + unhex(lines[i].substring(k, k+2)));
          j++;
        }
        //println();
      }
      prevGoTo = goTo;
      //println("sent " + num + " bytes, lines done = " + linesDone + " out of " + lines.length);
      message(connect_message, num, CalculateCrc(connect_message));
      //println("wait for response");
      percent = PApplet.parseFloat(linesDone)/PApplet.parseFloat(lines.length)*100;
      println("percent = " + percent);
      if (percent >= nextPercent) {
        bootTextarea.setText(bootTextarea.text() + "Programmed " + linesDone + " of " + lines.length + "\n");
        nextPercent += 10;
      }
      mode = 3;
      initTime = millis();
      while (mode == 3) {
        if (millis()-initTime > 10000) {
          println("did not respond to program packet");
          bootTextarea.setText(bootTextarea.text() + "Could not program...\n");
          program = 0;
          break;
        }
      }
      //println("got response");
    }
    else {
      linesDone = 0;
      prevGoTo = 0;
      program = 0;
      nextPercent = 0;
      bootTextarea.setText(bootTextarea.text() + "Programing complete!\n");
    }

    //Run(0);
  }

  if (plotMode) {
    plotGraph();
  }
  else {
    recTextarea.setText(recString);
  }
}

public void controlEvent(ControlEvent theEvent) {
  if (theEvent.isGroup()) {
    if (theEvent.name()=="bootList") {
      InitSerial(theEvent.group().value(), 0);
    }
    if (theEvent.name()=="debugList") {
      InitSerial(theEvent.group().value(), 1);
    }
    if (theEvent.name()=="DebugType") {
      if (theEvent.group().value() == 0) {
        recTextarea.setVisible(true);
        butClearDebug.setVisible(true);
        butSaveDebug.setVisible(true);
        //plotChart.setVisible(false);
        butClearPlot.setVisible(false);
        butSavePlot.setVisible(false);
        plotMode = false;
        println("text");
      }
      if (theEvent.group().value() == 1) {
        recTextarea.setVisible(false);
        butClearDebug.setVisible(false);
        butSaveDebug.setVisible(false);
        //plotChart.setVisible(true);
        butClearPlot.setVisible(true);
        butSavePlot.setVisible(true);
        plotMode = true;
        println("plot");
      }
    }
  }
  else {
  }
}

public void Select_HEX(int theValue) { 
  // myPorts[0].write("a\n"); // write an a
  println("select hex"); // print it to the debug screen as well

  loadPath = selectInput("Select your .hex file");  // Opens file chooser

  if (loadPath == null) {
    //println("null load path");
    txtlblHex.setValue("No HEX file selected");
    havePath = false;
  }
  else {
    if ((loadPath.substring(loadPath.length()-4, loadPath.length())).equals(".hex")) {
      havePath = true;
      //println("load path = " + loadPath);
      //println("len = " + loadPath.length());
      if (loadPath.length() > 25) {
        txtlblHex.setValue("HEX = ..." + loadPath.substring(loadPath.length()-25, loadPath.length()));
      }
      else {
        txtlblHex.setValue("HEX = " + loadPath);
      }
    }
    else {
      txtlblHex.setValue("No HEX file selected");
      havePath = false;
      //println("not a hex file");
    }
  }
}

public void Request_Boot(int theValue) { 
  println("request boot"); // print it to the debug screen as well
  requestBoot = 1;
}

public void Connect(int theValue) { 
  println("connect"); // print it to the debug screen as well
  tryConnect = 1;
}

public void Program(int theValue) { 
  println("program"); // print it to the debug screen as well

  program = 1; // do the rest in draw
}

public void Run(int theValue) {   
  byte[] connect_message = {
    5
  };
  println("run"); // print it to the debug screen as well
  bootTextarea.setText(bootTextarea.text() + "Leaving bootloader...\n");

  butProgram.setVisible(false);
  butRun.setVisible(false);

  message(connect_message, 1, CalculateCrc(connect_message));
}

public void Close_Boot_Port(int theValue) { 
  // myPorts[0].write("a\n"); // write an a

  comPorts[0].clear();
  comPorts[0].stop();

  serialBootcom = "";

  txtlblBootcom.setValue("Select a Bootloader port");

  serialBootOK = false;
  butCloseBoot.setVisible(false);
  bootListbox.setVisible(true);
  butSelecthex.setVisible(false);
  txtlblHex.setVisible(false);
  butRequestboot.setVisible(false);
  butConnect.setVisible(false);
  butProgram.setVisible(false);
  butRun.setVisible(false);
  bootTextarea.setVisible(false);

  bootTextarea.setText("");

  println("close boot port"); // print it to the debug screen as well
}

public void Close_Debug_Port(int theValue) { 
  // myPorts[0].write("a\n"); // write an a

  comPorts[1].clear();
  comPorts[1].stop();

  serialDebugcom = "";
  txtlblDebugcom.setValue("Select a debug port");

  serialDebugOK = false;
  debugListbox.setVisible(true);
  butCloseDebug.setVisible(false);
  debugTypeRadio.setVisible(false);
  inputTextfield.setVisible(false);
  inputTextfield.keepFocus(false);
  recTextarea.setVisible(false);
  butClearDebug.setVisible(false);
  butSaveDebug.setVisible(false);
  //plotChart.setVisible(true);
  butClearPlot.setVisible(false);
  butSavePlot.setVisible(false);

  plotMode = false;

  println("close debug port"); // print it to the debug screen as well
}

public void Clear_Debug(int theValue) { 
  recTextarea.setText("");
  recString = "";
  println("clear debug"); // print it to the debug screen as well
}

public void Save_Debug(int theValue) { 
  println("save debug"); // print it to the debug screen as well
  PrintWriter output;
  output = createWriter("debug_data.txt");
  output.println(recString);
  output.flush(); // Write the remaining data
  output.close(); // Finish the file
}

public void Clear_Plot(int theValue) { 
  println("clear plot"); // print it to the debug screen as well
  for (int i = 0; i < 500; i++) {
    buffA[i] = 0;
    buffB[i] = 0;
    buffC[i] = 0;
    buffD[i] = 0;
    buffE[i] = 0;
    buffF[i] = 0;
  }
  rollingIndex = 0;
}

public void Save_Plot(int theValue) { 
  println("save plot"); // print it to the debug screen as well
  save("plot_screenshot.png"); // screenshot

  PrintWriter output;
  output = createWriter("plot_data.txt");
  for (int ii = 0; ii < 500; ii++) {
    output.println(buffA[ii]+" "+buffB[ii]+" "+buffC[ii]+" "+buffD[ii]+" "+buffE[ii]+" "+buffF[ii]);
  }
  output.flush(); // Write the remaining data
  output.close(); // Finish the file
}

public void Exit_App(int theValue) { 
  println("exit");

  if (serialBootOK) {
    comPorts[0].clear();
    comPorts[0].stop();
  }

  if (serialDebugOK) {
    comPorts[1].clear();
    comPorts[1].stop();
  }

  exit();
}

public void Send_to_NU32(String theText) {
  println("send " + theText);
  comPorts[1].write(theText);
}

public void create_boot_serial() {
  txtlblBootcom = controlP5.addTextlabel("txtlblBootcom", "Select a bootloader port", 10, 10); // textlabel(name,text,x,y)
  txtlblBootcom.setColorValueLabel(0);

  bootListbox = controlP5.addListBox("bootList", 10, 30, 120, 120); //addListBox(name,x,y,width,height)
  bootListbox.captionLabel().toUpperCase(false);
  bootListbox.captionLabel().set("Ports available:");
  String portName;
  for (int i=0;i<Serial.list().length;i++) {
    portName = Serial.list()[i];
    if (portName.length() > 22) {
      portName = portName.substring(portName.length()-22, portName.length());
    }
    bootListbox.addItem("port: "+ portName, i); // addItem(name,value)
  }

  butCloseBoot = controlP5.addButton("Close_Boot_Port", 1, 10, 25, 90, 20); // buton(name,value,x,y,width,height)
  butCloseBoot.setVisible(false);
}

public void create_debug_serial() {
  txtlblDebugcom = controlP5.addTextlabel("txtlblDebugcom", "Select a debug port", 210, 10); // textlabel(name,text,x,y)
  txtlblDebugcom.setColorValueLabel(0);

  debugListbox = controlP5.addListBox("debugList", 210, 30, 120, 120); //addListBox(name,x,y,width,height)
  debugListbox.captionLabel().toUpperCase(false);
  debugListbox.captionLabel().set("Ports available:");
  //bootListbox.captionLabel().setControlFont(font);
  String portName;
  for (int i=0;i<Serial.list().length;i++) {
    portName = Serial.list()[i];
    if (portName.length() > 22) {
      portName = portName.substring(portName.length()-22, portName.length());
    }
    debugListbox.addItem("port: "+ portName, i); // addItem(name,value)
  }

  butCloseDebug = controlP5.addButton("Close_Debug_Port", 1, 210, 25, 90, 20); // buton(name,value,x,y,width,height)
  butCloseDebug.setVisible(false);
}

public void InitSerial(float portValue, int type) {
  if (type == 0) { // boot

    if (serialDebugcom.equals(Serial.list()[PApplet.parseInt(portValue)])) {
      println("don't open that one");
    }
    else {
      comPorts[0] = new Serial(this, Serial.list()[PApplet.parseInt(portValue)], 115200); // initialize the port

      serialBootcom = Serial.list()[PApplet.parseInt(portValue)];

      // read bytes into a buffer until you get a EOT
      comPorts[0].bufferUntil(4);
      println("done init boot serial");

      if (serialBootcom.length() > 15) {
        serialBootcom = serialBootcom.substring(serialBootcom.length()-15, serialBootcom.length());
      }

      txtlblBootcom.setValue("Opened " +  serialBootcom + " for bootloading");
      println("initializing serial " + PApplet.parseInt(portValue) + " in serial.list()"); 

      serialBootOK = true;
      butCloseBoot.setVisible(true);
      bootListbox.setVisible(false);
      butSelecthex.setVisible(true);
      txtlblHex.setVisible(true);
      butRequestboot.setVisible(true);
      butConnect.setVisible(true);
      butProgram.setVisible(false);
      butRun.setVisible(false);
      bootTextarea.setVisible(true);
    }
  }
  if (type == 1) { // debug
    if (serialBootcom.equals(Serial.list()[PApplet.parseInt(portValue)])) {
      println("don't open that one");
    }
    else {
      comPorts[1] = new Serial(this, Serial.list()[PApplet.parseInt(portValue)], 115200); // initialize the port

      serialDebugcom = Serial.list()[PApplet.parseInt(portValue)];

      // read bytes into a buffer until you get a linefeed (ASCII 10):
      //comPorts[1].bufferUntil('\n'); // '\n'
      println("done init debug serial");
      
      //if (serialDebugcom.length() > 22) {
      //  serialDebugcom = serialDebugcom.substring(serialDebugcom.length()-22, serialDebugcom.length());
      //}

      txtlblDebugcom.setValue("Opened " +  serialDebugcom + " for debugging");
      println("initializing serial " + PApplet.parseInt(portValue) + " in serial.list()"); 

      serialDebugOK = true;
      debugListbox.setVisible(false);
      butCloseDebug.setVisible(true);
      debugTypeRadio.setVisible(true);
      inputTextfield.setVisible(true);
      inputTextfield.keepFocus(true);
      debugTypeRadio.activate(0);
    }
  }
  //String portPos = Serial.list()[int(portValue)]; // grab the name of the serial port 

  //txtlblWhichcom.setValue("COM Initialized = " + portPos);

  //myPorts[0] = new Serial(this, portPos, 19200); // initialize the port

  // read bytes into a buffer until you get a linefeed (ASCII 10):
  //myPorts[0].bufferUntil('\n');
  //println("done init serial");
}

// serial event, check which port generated the event 
public void serialEvent(Serial thisPort) { 
  // variable to hold the number of the port:
  int portNumber = -1;

  // iterate over the list of ports opened, and match the one that generated this event:
  for (int p = 0; p < comPorts.length; p++) {
    if (thisPort == comPorts[p]) {
      portNumber = p;
    }
  }

  if (portNumber == 0) { // bootloader  
    String inString = thisPort.readStringUntil(4);//(thisPort.readString());
    //println("bootloader got: " + inString + "len = " + inString.length());

    rec = rec + inString;
    int lenStr = rec.length();
    //println("rec len = " + lenStr);

    if (lenStr > 1) {
      //println(">" + byte(rec.charAt(lenStr-2)));
      if (PApplet.parseByte(rec.charAt(lenStr-2)) != 16) {
        parse_message(rec);
        rec = "";
      }
      else {
        if (lenStr > 3) {
          if (PApplet.parseByte(rec.charAt(lenStr-3)) != 16) {
            //println("not the end");
          }
          else {
            //println("too many 16's in parse");
          }
        }
      }
    }
  }

  if (portNumber == 1) { // debug
    // read the serial buffer until a newline appears
    //String myString = thisPort.readStringUntil('\n');
    //myString = trim(myString); // ditch the newline
    //println("got debug: " + myString);

    if (plotMode == false) {
      char inByte = thisPort.readChar();
      //recTextarea.setText(recTextarea.text() + inByte);
      if (inByte == '\n') {
        recString = recString + '\r' + '\n';
      }
      else {
        recString = recString + inByte;
      }
    }
    else {
      char inByte = thisPort.readChar();
      if (inByte == '\n') {
        addToPlot();
        plotRec = "";
      }
      else {
        plotRec = plotRec + inByte;
        if (plotRec.length() > 200) {
          plotRec = "";
        }
      }
    }
  }
} // end serialEvent

public void message(byte[] data, int len, int crc) {
  int i, j, num;

  num = len+4;

  for (i=0; i<len; i++) {
    if ((data[i] == 1)||(data[i] == 4)||(data[i] == 16)) {
      num++;
    }
  }
  if ((PApplet.parseByte(crc) == 1)||(PApplet.parseByte(crc) == 4)||(PApplet.parseByte(crc) == 16)) {
    num++;
  }
  if ((PApplet.parseByte((crc>>8)) == 1)||(PApplet.parseByte((crc>>8)) == 4)||(PApplet.parseByte((crc>>8)) == 16)) {
    num++;
  }

  //println(data);
  //println("num = " + num);

  byte[] dataBfr = new byte[num];

  j = 1;
  dataBfr[0] = 1; // SOH
  for (i=0; i<len; i++) {
    if ((data[i] == 1)||(data[i] == 4)||(data[i] == 16)) {
      dataBfr[j] = 16;
      j++;
      dataBfr[j] = data[i];
    }
    else {
      dataBfr[j] = data[i];
    }
    j++;
  }
  if ((PApplet.parseByte(crc) == 1)||(PApplet.parseByte(crc) == 4)||(PApplet.parseByte(crc) == 16)) {
    dataBfr[j] = 16;
    j++;
  }
  dataBfr[j] = PApplet.parseByte(crc); // CRCL
  j++;
  if ((PApplet.parseByte((crc>>8)) == 1)||(PApplet.parseByte((crc>>8)) == 4)||(PApplet.parseByte((crc>>8)) == 16)) {
    dataBfr[j] = 16;
    j++;
  }
  dataBfr[j] = PApplet.parseByte(crc>>8); // CRCH
  j++;
  dataBfr[j] = 4; // EOT

  //println(dataBfr);

  comPorts[0].write(dataBfr);
}

public int CalculateCrc(byte[] data)
{
  int i;
  int len = data.length;
  int crc = 0;
  int j = 0;

  for (j=0;j<len;j++)
  {
    i = (crc >> 12) ^ (data[j] >> 4);
    crc = crc_table[i & 0x0F] ^ (crc << 4);
    i = (crc >> 12) ^ (data[j] >> 0);
    crc = crc_table[i & 0x0F] ^ (crc << 4);
  } 

  return (crc & 0xFFFF);
}

public void parse_message(String got) {

  byte[] in = new byte[got.length()];

  int i;
  for (i=0; i<got.length(); i++) {
    in[i] = PApplet.parseByte(got.charAt(i));
  }
  //println(in);

  if ((in[1] == 16)&&(in[2]==1)) { // bootloader ver
    int bootV1, bootV2;
    if (in[3] == 16) {
      bootV1 = in[4];
      if (in[5] == 16) {
        bootV2 = in[6];
      }
      else {
        bootV2 = in[5];
      }
    }
    else {
      bootV1 = in[3];
      if (in[4] == 16) {
        bootV2 = in[5];
      }
      else {
        bootV2 = in[4];
      }
    }
    bootTextarea.setText(bootTextarea.text() + "Connected to bootloader v"+bootV1+"."+bootV2+"!\n");
    mode = 0;
  }

  if ((in[1] == 2)) { // erase
    bootTextarea.setText(bootTextarea.text() + "Flash erased!\n");
    mode = 0;
  }

  if ((in[1] == 3)) { // program
    mode = 0;
  }
}

public void addToPlot() {
  if (plotRec != null) {
    int sensors[] = PApplet.parseInt(split(plotRec, ' '));
    if (sensors.length == 0) {
      buffA[rollingIndex] = 0;
      buffB[rollingIndex] = 0;
      buffC[rollingIndex] = 0;
      buffD[rollingIndex] = 0;
      buffE[rollingIndex] = 0;
      buffF[rollingIndex] = 0;
    }

    if (sensors.length == 1) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = 0;
      buffC[rollingIndex] = 0;
      buffD[rollingIndex] = 0;
      buffE[rollingIndex] = 0;
      buffF[rollingIndex] = 0;
    }

    if (sensors.length == 2) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = sensors[1];
      buffC[rollingIndex] = 0;
      buffD[rollingIndex] = 0;
      buffE[rollingIndex] = 0;
      buffF[rollingIndex] = 0;
    }

    if (sensors.length == 3) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = sensors[1];
      buffC[rollingIndex] = sensors[2];
      buffD[rollingIndex] = 0;
      buffE[rollingIndex] = 0;
      buffF[rollingIndex] = 0;
    }

    if (sensors.length == 4) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = sensors[1];
      buffC[rollingIndex] = sensors[2];
      buffD[rollingIndex] = sensors[3];
      buffE[rollingIndex] = 0;
      buffF[rollingIndex] = 0;
    }

    if (sensors.length == 5) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = sensors[1];
      buffC[rollingIndex] = sensors[2];
      buffD[rollingIndex] = sensors[3];
      buffE[rollingIndex] = sensors[4];
      buffF[rollingIndex] = 0;
    }
    if (sensors.length == 6) {
      buffA[rollingIndex] = sensors[0];
      buffB[rollingIndex] = sensors[1];
      buffC[rollingIndex] = sensors[2];
      buffD[rollingIndex] = sensors[3];
      buffE[rollingIndex] = sensors[4];
      buffF[rollingIndex] = sensors[5];
    }

    rollingIndex++;
    if (rollingIndex == 500) {
      rollingIndex = 0;
    }
  }
}

public void plotGraph() {
  int i;
  int plotted = 0;
  int zero_x = 210;
  int zero_y = 595;

  int text_x = 695;
  int text_y = 135;

  fill(255);
  rect(zero_x, zero_y-512, 500, 512);

  fill(0);
  text("send up to 6 integers valued 0-512", 375, 30);
  text("separated by spaces ending with a slash n", 375, 40);

  fill(255, 0, 0);  // red
  text("a", text_x, text_y);
  fill(0, 255, 0);  // green
  text("b", text_x, text_y+10);
  fill(0, 0, 255);  // blue
  text("c", text_x, text_y+20);
  fill(150, 15, 150);  // purple
  text("d", text_x, text_y+30);
  fill(252, 156, 0);  // orange
  text("e", text_x, text_y+40);
  fill(0, 252, 246);  // light blue
  text("f", text_x, text_y+50);

  stroke(0);
  for (i = zero_x+100; i < zero_x+500; i=i+100) {
    line(i, zero_y, i, zero_y-512);
  }
  for (i = zero_y-100; i > zero_y-512; i=i-100) {
    line(zero_x, i, zero_x+500, i);
  }

  noStroke();
  i = rollingIndex;
  while (plotted < 500) { 
    fill(255, 0, 0);  // red
    ellipse(plotted+zero_x, zero_y-buffA[i], 4, 4);

    fill(0, 255, 0);  // green
    ellipse(plotted+zero_x, zero_y-buffB[i], 4, 4);

    fill(0, 0, 255);  // blue
    ellipse(plotted+zero_x, zero_y-buffC[i], 4, 4);

    fill(150, 15, 150);  // purple
    ellipse(plotted+zero_x, zero_y-buffD[i], 4, 4);

    fill(252, 156, 0);  // orange
    ellipse(plotted+zero_x, zero_y-buffE[i], 4, 4);

    fill(0, 252, 246);  // light blue
    ellipse(plotted+zero_x, zero_y-buffF[i], 4, 4);

    i++;
    if (i == 500) {
      i = 0;
    }

    plotted++;
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "NU32_utility" });
  }
}
